<script>
	import 'intl-tel-input/build/css/intlTelInput.min.css'

	import axios from "axios"
	import intlTelInput from "intl-tel-input"
	import { error } from "@/stores/form"

	export let value = ""
	export let placeholder = ""
	export let disabled = false
	export let required = false

	let iti = null
	let input = null

	let inputValue = value
	let onFocus = false

	$: {
		if (input) {
			iti = intlTelInput(input, {
				utilsScript: '../../../node_modules/intl-tel-input/build/js/utils.js',
				preferredCountries: [],
				separateDialCode: true,
				initialCountry: "auto",
				autoPlaceholder: "off",
				geoIpLookup: async success => {
					try {
						const { data } = await axios.get("https://ipinfo.io?token=244d5d6c748e32").catch(() => ({ data: { country: "ar" } }))
						let { country } = data
						let countryCode = country || "ar"
						success(countryCode)
					} catch(err) {
						console.error(err)
						success(import.meta.env.DEV ? "ru" : "ar")
					}
				}
			})
			input.addEventListener("focus", () => onFocus = true)
			input.addEventListener("blur", () => onFocus = false)
		}
	}

	const handleInput = () => {
		if (!iti) return value = ""
		if (!iti.getNumber()) return
		
		const valid =	iti.isValidNumber()
		
		$error.invalidPhone = !valid
		if (!valid) return value = ""

		const phone = iti.getNumber()
		value = phone
	}

	$: { value; (() => {
			setTimeout(() => {
				handleInput()
			}, 50)
		})();
	}

</script>

<div class="phone-input">
	<input 
		bind:this={input}
		bind:value={inputValue}
		{placeholder}
		{disabled}
		on:input={handleInput}
		class="input">
</div>

{#if $$slots.default}
	<label class="label is-flex is-align-items-center" class:hidden={inputValue || onFocus}>
		<slot />
		{#if required}
			<span class="has-text-red">&nbsp;*</span>
		{/if}
	</label>
{/if}

<style lang="scss">
	$left: 6.375rem;

	.input {
		padding-left: $left!important;
	}

	.label {
		left: $left!important;
	}

	.phone-input {
		:global(.iti__selected-flag) {
			padding-left: 0;
			padding-right: .75rem;
			&::before {
				content: "";
				display: block;
				height: 1.5rem;
				width: 1px;
				background: $gray-text;
				margin: auto 0;
				position: absolute;
				top: 0;
				right: 0;
				bottom: 0;
			}
		}

		:global(.iti) {
			width: 100%;
		}

		:global(.iti__flag-container) {
			z-index: 3;
		}

		:global(.iti__flag) {
			scale: .8;
		}

		:global(.iti__selected-dial-code) {
			font-size: 1.125rem;
			font-weight: 300;
			text-align: center;
			color: $white;
			width: 2.75rem;
			margin-left: .2rem;
		}

		:global(.iti__arrow) {
			margin-left: .5rem;
			border-top: 3.33px solid $white;
		}
		
		:global(.iti__arrow--up) {
			border-top: none;
			border-bottom: 3.33px solid $white;
		}

		:global(.iti__country-list) {
			margin: 0 auto;
			left: -3rem;
			right: -14rem;
		}

		:global(.iti__country) {
			display: flex;
			align-items: flex-start;
			justify-content: flex-start;		
		}
		:global(.iti__country .iti__flag-box) {
			display: flex;
			align-items: center;
			justify-content: center;
			height: 1.5rem;
			order: 1;
		}
		:global(.iti__country .iti__dial-code) {
			color: $black;
			order: 2;
			width: 2.6rem;
			margin-right: .5rem;
		}
		:global(.iti__country .iti__country-name) {
			color: $grey;
			white-space: break-spaces;
			flex: 1;
			order: 3;
		}
	}
</style>